<!DOCTYPE html>
<html>
  <head>
    <title>Task 48.10</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import them style bootstrap cho datatable -->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />

    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <!-- Import awesome-->
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css"
    />
  </head>

  <body>
    <div class="container-fluid p-3">
      <div class="row">
        <div class="col-sm-12 text-center">
          <h3>Learning History</h3>
        </div>
      </div>
      <div class="row form-group py-3 bg-light rounded">
        <label class="col-sm-2 col-form-label text-center"
          ><b>Student</b></label
        >
        <div class="col-sm-3">
          <select id="select-student" class="form-control">
            <option value="0">--Select Student--</option>
          </select>
        </div>
        <label class="col-sm-2 col-form-label text-center"
          ><b>Subject</b></label
        >
        <div class="col-sm-3">
          <select id="select-subject" class="form-control">
            <option value="0">--Select Subject--</option>
          </select>
        </div>
        <div class="col-sm-2">
          <button id="btn-filter" class="btn btn-success w-100">
            Filter Data
          </button>
        </div>
      </div>
      <div class="row form-group">
        <button class="btn btn-success" id="add-data">
          <i class="fa-regular fa-plus"></i> &nbsp;Thêm
        </button>
      </div>
      <hr />
      <div class="row form-group">
        <div class="col-sm-12">
          <table
            id="table-grade"
            class="table table-bgradeed table-striped table-hover"
          >
            <thead class="thead-dark">
              <tr>
                <th>No.</th>
                <th>Student</th>
                <th>Subject</th>
                <th>Grade</th>
                <th>Exam Date</th>
                <th>Action</th>
              </tr>
            </thead>
            <tbody></tbody>
          </table>
        </div>
      </div>
    </div>

    <!-- Create grade modal -->
    <div>
      <div id="add-grade-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">
                Information Detail
              </h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-add-idstudent">Id student:</label>
                  </div>
                  <div class="col-sm-9">
                    <input
                      type="text"
                      id="input-add-idstudent"
                      name="addidstudent"
                      placeholder="...."
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-add-idsubject">Id Subject:</label>
                  </div>
                  <div class="col-sm-9">
                    <input
                      type="text"
                      id="input-add-idsubject"
                      name="addidsubject"
                      placeholder="...."
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-add-grade">Grade:</label>
                  </div>
                  <div class="col-sm-9">
                    <input
                      type="text"
                      id="input-add-grade"
                      name="addgrade"
                      placeholder="...."
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-add-day-test">Day test:</label>
                  </div>
                  <div class="col-sm-9">
                    <input
                      type="text"
                      id="input-add-day-test"
                      name="adddaytest"
                      placeholder="...."
                      class="form-control"
                    />
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="row form-group">
                <div class="col-sm-6">
                  <button class="btn btn-primary" id="btn-add-confirm">
                    Confirm
                  </button>
                </div>
                <div class="col-sm-6">
                  <button class="btn btn-danger" id="btn-add-cancel">
                    Cancel
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- edit grade modal -->
    <div>
      <div id="edit-grade-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">Edit Information</h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <form>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-edit-idstudent">Id student:</label>
                  </div>
                  <div class="col-sm-9">
                    <input
                      type="text"
                      id="input-edit-idstudent"
                      name="editidstudent"
                      placeholder="...."
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-edit-idsubject">Id Subject:</label>
                  </div>
                  <div class="col-sm-9">
                    <input
                      type="text"
                      id="input-edit-idsubject"
                      name="addidsubject"
                      placeholder="...."
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-edit-grade">Grade:</label>
                  </div>
                  <div class="col-sm-9">
                    <input
                      type="text"
                      id="input-edit-grade"
                      name="editgrade"
                      placeholder="...."
                      class="form-control"
                    />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-edit-day-test">Day test:</label>
                  </div>
                  <div class="col-sm-9">
                    <input
                      type="text"
                      id="input-edit-day-test"
                      name="editdaytest"
                      placeholder="...."
                      class="form-control"
                    />
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="row form-group">
                <div class="col-sm-6">
                  <button class="btn btn-primary" id="btn-edit-confirm">
                    Confirm
                  </button>
                </div>
                <div class="col-sm-6">
                  <button class="btn btn-danger" id="btn-edit-cancel">
                    Cancel
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- delete grade modal -->
    <div>
      <div id="delete-grade-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">
                Delete Information
              </h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <p>Do you sure delete information?</p>
            </div>
            <div class="modal-footer">
              <div class="row form-group">
                <div class="col-sm-6">
                  <button class="btn btn-primary" id="btn-delete-confirm">
                    Confirm
                  </button>
                </div>
                <div class="col-sm-6">
                  <button class="btn btn-danger" id="btn-delete-cancel">
                    Cancel
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </body>

  <script>
    $(document).ready(function () {
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      var gStudentObj = [];
      var gSubjectObj = [];
      var gGradeObj = [];
      var gSTT = 1;
      var gGradeId;

      const gTABLE_ROW = [
        "id",
        "studentId",
        "subjectId",
        "grade",
        "examDate",
        "action",
      ];
      const gSTT_COL = 0;
      const gSTUDENT_COL = 1;
      const gSUBJECT_COL = 2;
      const gGRADE_COL = 3;
      const gEXAM_DATE_COL = 4;
      const gACTION_COL = 5;

      var gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";

      var gTableGrade = $("#table-grade").DataTable({
        columns: [
          { data: gTABLE_ROW[gSTT_COL] },
          { data: gTABLE_ROW[gSTUDENT_COL] },
          { data: gTABLE_ROW[gSUBJECT_COL] },
          { data: gTABLE_ROW[gGRADE_COL] },
          { data: gTABLE_ROW[gEXAM_DATE_COL] },
          { data: gTABLE_ROW[gACTION_COL] },
        ],
        columnDefs: [
          {
            targets: gSTT_COL,
            className: "text-center text-info",
            render: function () {
              return gSTT++;
            },
          },
          {
            targets: gSTUDENT_COL,
            render: getStudentNameByStudentId,
          },
          {
            targets: gSUBJECT_COL,
            render: getSubjectNameBySubjectId,
          },
          {
            targets: gGRADE_COL,
            className: "text-center",
          },
          {
            targets: gEXAM_DATE_COL,
            className: "text-center",
          },
          {
            targets: gACTION_COL, //cột Action
            className: "text-center",
            defaultContent: `
                            <button id= "edit-grade"  <i title = 'DEATIL' class="fas fa-pencil-alt text-info" style = "cursor:pointer; border: 1px white;"></i></button> &nbsp;
                            <button id= "delete-grade" <i title = 'Delete' class="fa-solid fa-trash text-danger" style = "cursor:pointer;border: 1px white;"></i></button>`,
          },
        ],
      });

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      onPageLoading();
      // gán sự kiện click button Filter Data
      $(document).on("click", "#btn-filter", onBtnFilterClick);
      $(document).on("click", "#add-data", onBtnFormAddDataClick);
      $(document).on("click", "#btn-add-confirm", onBtnConfirmAddDataClick);
      $(document).on("click", "#btn-add-cancel", onBtnCancelAddDataClick);

      $("#table-grade").on("click", "#edit-grade", function () {
        onBtnEditDataClick(this);
      });
      $(document).on("click", "#btn-edit-confirm", onBtnConfirmEditDataClick);
      $(document).on("click", "#btn-edit-cancel", onBtnCancelEditDataClick);

      $("#table-grade").on("click", "#delete-grade", function () {
        onBtnDeleteDataClick(this);
      });
      $(document).on(
        "click",
        "#btn-delete-confirm",
        onBtnConfirmDeleteDataClick
      );
      $(document).on("click", "#btn-delete-cancel", onBtnCancelDeleteDataClick);

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      // function xử lý sự kiện tải trang/F5
      function onPageLoading() {
        callApiToGetStudentObj();
        callApiToGetSubjectObj();
        callApiToGetGradeObj();

        loadStudentDataToSelect();
        loadSubjectDataToSelect();
      }

      //hàm call API to get all student
      function callApiToGetStudentObj() {
        $.ajax({
          url: gBASE_URL + "/students",
          type: "GET",
          async: false,
          dataType: "json",
          success: function (responseObject) {
            gStudentObj = responseObject;
            console.log(gStudentObj);
          },
          error: function (error) {
            console.assert(error.responseText);
          },
        });
      }

      //hàm call API to get all subject
      function callApiToGetSubjectObj() {
        $.ajax({
          url: gBASE_URL + "/subjects",
          type: "GET",
          async: false,
          dataType: "json",
          success: function (responseObject) {
            gSubjectObj = responseObject;
            console.log(gSubjectObj);
          },
          error: function (error) {
            console.assert(error.responseText);
          },
        });
      }

      //hàm call API to get all subject
      function callApiToGetGradeObj() {
        $.ajax({
          url: gBASE_URL + "/grades",
          type: "GET",
          // async: false,
          dataType: "json",
          success: function (responseObject) {
            gGradeObj = responseObject;
            showDataToTable(responseObject);
          },
          error: function (error) {
            console.assert(error.responseText);
          },
        });
      }

      // function xử lý sự kiện click button Filter Data
      function onBtnFilterClick() {
        // khai báo đối tượng chứa dữ liệu
        let vFilterData = {
          studentId: "",
          subjectId: "",
        };
        // B1: Thu thập dữ liệu
        getFilterData(vFilterData);
        debugger;
        // B2: Kiểm tra dữ liệu
        let vDataValid = checkFilterData(vFilterData);
        if (vDataValid) {
          // B3: Xử lý hiển thị
          let vFilteredObject = findStudentByFilter(vFilterData);
          var vTable = $("#table-grade"); //truy vấn đến bảng có id = table-users
          vTable.find("tr:gt(0)").html(""); //xóa trắng bảng (k xóa header)
          if (vFilteredObject.length > 0) {
            //hiện thông báo đã tìm được
            alert("Tìm thấy " + vFilteredObject.length + " kết quả phù hợp");
            //hiển thị danh sách dữ liệu tìm được ra table
            showDataToTable(vFilteredObject);
          } else {
            alert("Không tìm thấy kết quả phù hợp");
            return false;
          }
        }
      }

      function onBtnFormAddDataClick() {
        $("#add-grade-modal").modal("show");
      }

      function onBtnConfirmAddDataClick() {
        "use strict";
        var vGradeAddObj = {
          studentId: "",
          subjectId: "",
          grade: 0,
          examDate: "",
        };
        // B1: Thu thập dữ liệu
        getAddGradeData(vGradeAddObj);
        // B2: Validate update
        var vIsValidate = validateData(vGradeAddObj);
        if (vIsValidate) {
          // B3: update order
          $.ajax({
            url: gBASE_URL + "/grades",
            type: "POST",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(vGradeAddObj),
            success: function (paramRes) {
              // B4: xử lý front-end
              handleAddGradeSuccess();
            },
            error: function (paramErr) {
              console.log(paramErr.status);
            },
          });
        }
      }

      function onBtnCancelAddDataClick() {
        $("#add-grade-modal").modal("hide");
      }

      function onBtnConfirmEditDataClick() {
        "use strict";
        var vGradeEditObj = {
          studentId: "",
          subjectId: "",
          grade: 0,
          examDate: "",
        };
        // B1: Thu thập dữ liệu
        getEditGradeData(vGradeEditObj);
        // B2: Validate update
        var vIsValidate = validateData(vGradeEditObj);
        if (vIsValidate) {
          // B3: update order
          $.ajax({
            url: gBASE_URL + "/grades/" + gGradeId,
            type: "PUT",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(vGradeEditObj),
            success: function (paramRes) {
              // B4: xử lý front-end
              handleEditGradeSuccess();
            },
            error: function (paramErr) {
              console.log(paramErr.status);
            },
          });
        }
      }

      function onBtnCancelEditDataClick() {
        $("#edit-grade-modal").modal("hide");
      }

      // Hàm xử lý sự kiện khi icon edit trên bảng đc click
      function onBtnEditDataClick(paramBtnEdit) {
        "use strict";
        console.log("Button edit được click");
        // hàm dựa vào button detail (edit or delete) xác định đc id
        var vTableRow = $(paramBtnEdit).parents("tr");
        var vGradeRowData = gTableGrade.row(vTableRow).data();
        gGradeId = vGradeRowData.id;
        console.log("ID lấy được: " + gGradeId);
        getGradeById(gGradeId);
      }

      // Hàm xử lý sự kiện khi icon delete trên bảng đc click
      function onBtnDeleteDataClick(paramBtnEdit) {
        "use strict";
        console.log("Button delete được click");
        // hàm dựa vào button detail (edit or delete) xác định đc id
        var vTableRow = $(paramBtnEdit).parents("tr");
        var vGradeRowData = gTableGrade.row(vTableRow).data();
        gGradeId = vGradeRowData.id;
        console.log("ID lấy được: " + gGradeId);
        // hiển thị modal lên
        $("#delete-grade-modal").modal("show");
      }

      //sự kiện confirm delete grade
      function onBtnConfirmDeleteDataClick() {
        deleteGradeById(gGradeId);
      }
      //cancel delete grade
      function onBtnCancelDeleteDataClick() {
        $("#delete-grade-modal").modal("hide");
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      // function gán data cho Table
      function showDataToTable(paramData) {
        gSTT = 1;
        gTableGrade.clear();
        gTableGrade.rows.add(paramData);
        gTableGrade.draw();
      }

      // function lấy tên Student theo studentId
      function getStudentNameByStudentId(paramStudentId) {
        let vIndex = 0;
        let vFound = false;
        let vStudentName = "";
        while (!vFound && vIndex < gStudentObj.length) {
          if (gStudentObj[vIndex].id == paramStudentId) {
            vStudentName =
              gStudentObj[vIndex].firstname +
              " " +
              gStudentObj[vIndex].lastname;
            vFound = true;
          }
          vIndex++;
        }
        return vStudentName;
      }

      // function lấy tên Subject theo Subject ID
      function getSubjectNameBySubjectId(paramSubjectId) {
        let vIndex = 0;
        let vFound = false;
        let vSubjectName = "";
        while (!vFound && vIndex < gSubjectObj.length) {
          if (gSubjectObj[vIndex].id == paramSubjectId) {
            vSubjectName = gSubjectObj[vIndex].subjectName;
            vFound = true;
          }
          vIndex++;
        }
        return vSubjectName;
      }

      // function thu thập dữ liệu filter data trên form
      // function return đối tượng paramFilterData được tham số hóa
      function getFilterData(paramFilterData) {
        paramFilterData.studentId = $("#select-student").val();
        paramFilterData.subjectId = $("#select-subject").val();
      }

      // function kiểm tra dữ liệu
      function checkFilterData(paramFilterData) {
        if (
          paramFilterData.studentId == "0" &&
          paramFilterData.subjectId == "0"
        ) {
          alert("Please select Student or Subject to filter data");
          return false;
        }
        return true;
      }

      function findStudentByFilter(paramKeyWordObj) {
        "use strict";
        const bArrResultObj = [];
        //kiểm tra truồng hợp nếu StudentID và SubjectID được nhập
        if (
          paramKeyWordObj.studentId != "0" &&
          paramKeyWordObj.subjectId != "0"
        ) {
          for (let bI = 0; bI < gGradeObj.length; bI++) {
            const bIStudentObj = gGradeObj[bI];
            //thực hiện so sánh từ khóa được nhập vào và dữ liệu user
            if (
              paramKeyWordObj.studentId == bIStudentObj.studentId &&
              paramKeyWordObj.subjectId == bIStudentObj.subjectId
            ) {
              //thêm đối tượng thỏa mãn điều kiện vào array
              bArrResultObj.push(bIStudentObj);
            }
          }
        }

        //kiểm tra trường hợp nếu StudentID hoặc SubjectID được nhập
        if (
          paramKeyWordObj.studentId != "0" ||
          paramKeyWordObj.subjectId != ""
        ) {
          for (let bI = 0; bI < gGradeObj.length; bI++) {
            const bIStudentObj = gGradeObj[bI];
            //thực hiện so sánh từ khóa được nhập vào và dữ liệu user
            if (
              paramKeyWordObj.studentId == bIStudentObj.studentId ||
              paramKeyWordObj.subjectId == bIStudentObj.subjectId
            ) {
              //thêm đối tượng thỏa mãn điều kiện vào array
              bArrResultObj.push(bIStudentObj);
            }
          }
        }

        return bArrResultObj;
      }

      // function load student data vào select
      function loadStudentDataToSelect() {
        for (let bStudent of gStudentObj) {
          $("#select-student").append(
            $("<option>")
              .val(bStudent.id)
              .text(bStudent.firstname + " " + bStudent.lastname)
          );
        }
      }

      // function load subject data vào select
      function loadSubjectDataToSelect() {
        for (let bSubject of gSubjectObj) {
          $("#select-subject").append(
            $("<option>").val(bSubject.id).text(bSubject.subjectName)
          );
        }
      }

      // hàm thu thập dữ liệu để update grade
      function getAddGradeData(paramGradeObj) {
        paramGradeObj.studentId = $("#input-add-idstudent").val().trim();
        paramGradeObj.subjectId = $("#input-add-idsubject").val().trim();
        paramGradeObj.grade = $("#input-add-grade").val().trim();
        paramGradeObj.examDate = $("#input-add-day-test").val().trim();
      }

      // hàm validate data
      function validateData(paramGradeObj) {
        if (paramGradeObj.studentId === "") {
          alert("Mời nhập id sinh viên.");
          return false;
        }
        if (isNaN(paramGradeObj.studentId)) {
          alert("Id sinh viên phải là số.");
          return false;
        }
        if (paramGradeObj.subjectId === "") {
          alert("Mời nhập id môn học.");
          return false;
        }
        if (isNaN(paramGradeObj.subjectId)) {
          alert("Id môn học phải là số.");
          return false;
        }
        if (paramGradeObj.grade == "") {
          alert("Mời nhập điểm.");
          return false;
        }
        if (isNaN(paramGradeObj.grade)) {
          alert("Điểm phải là số.");
          return false;
        }
        if (paramGradeObj.examDate === "") {
          alert("Mời nhập ngày thi.");
          return false;
        }

        return true;
      }

      //hàm confirm thành công
      function handleAddGradeSuccess() {
        alert("Add grade successfully!");
        callApiToGetGradeObj();
        resetDetailGradeForm();
        $("#add-grade-modal").modal("hide");
      }

      // hàm xóa trắng form detail modal
      function resetDetailGradeForm() {
        $("#input-add-idstudent").val("");
        $("#input-add-idsubject").val("");
        $("#input-add-grade").val("");
        $("#input-add-day-test").val("");
      }

      // hàm get grades by id
      function getGradeById(paramGradeId) {
        $.ajax({
          url: gBASE_URL + "/grades/" + gGradeId,
          type: "GET",
          async: false,
          success: function (paramOrderRes) {
            console.log(paramOrderRes);
            showGradeDataToModal(paramOrderRes);
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
        // hiển thị modal lên
        $("#edit-grade-modal").modal("show");
      }

      // hàm show order obj lên modal
      function showGradeDataToModal(paramGradeObj) {
        $("#input-edit-idstudent").val(paramGradeObj.studentId);
        $("#input-edit-idsubject").val(paramGradeObj.subjectId);
        $("#input-edit-grade").val(paramGradeObj.grade);
        $("#input-edit-day-test").val(paramGradeObj.examDate);
      }

      // hàm thu thập dữ liệu để update grade
      function getEditGradeData(paramGradeObj) {
        paramGradeObj.studentId = $("#input-edit-idstudent").val().trim();
        paramGradeObj.subjectId = $("#input-edit-idsubject").val().trim();
        paramGradeObj.grade = $("#input-edit-grade").val().trim();
        paramGradeObj.examDate = $("#input-edit-day-test").val().trim();
      }

      //hàm confirm thành công
      function handleEditGradeSuccess() {
        alert("Edit grade successfully!");
        callApiToGetGradeObj();
        resetEditDetailGradeForm();
        $("#edit-grade-modal").modal("hide");
      }

      // hàm xóa trắng form detail modal
      function resetEditDetailGradeForm() {
        $("#input-edit-idstudent").val("");
        $("#input-edit-idsubject").val("");
        $("#input-edit-grade").val("");
        $("#input-edit-day-test").val("");
      }

      // hàm get grades by id
      function deleteGradeById(paramGradeId) {
        $.ajax({
          url: gBASE_URL + "/grades/" + gGradeId,
          type: "DELETE",
          async: false,
          success: function (paramOrderRes) {
            console.log(paramOrderRes);
            handleDeleteGradeSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }

      //hàm confirm delete thành công
      function handleDeleteGradeSuccess() {
        alert("Delete grade successfully!");
        callApiToGetGradeObj();
        resetDetailGradeForm();
        $("#delete-grade-modal").modal("hide");
      }
    });
  </script>
</html>
